<template>
    <div class="dbaas-calculator">
        <h4>Parameters</h4>
        <table>
            <tr>
                <td class="label">Cores: <strong>{{cores}}</strong></td>
                <td class="input"><input type="range" v-model="cores" min="1" max="8"/></td>
            </tr>
            <tr>
                <td class="label">Memory: <strong>{{memoryGB}} GB</strong></td>
                <td class="input"><input type="range" v-model="memoryGB" min="1" max="32"/></td>
            </tr>
            <tr>
                <td class="label">Storage: <strong>{{storageGB}} GB</strong></td>
                <td class="input"><input type="range" v-model="storageGB" min="1" max="500"/></td>
            </tr>
        </table>
        <button v-for="preset in presets" v-on:click="applyPreset(preset)">
            {{preset.cores}} cores {{preset.memoryGB}}/{{preset.storageGB}} GB
        </button>
        <h4>Vendor Monthly Estimates</h4>
        <table>
            <thead>
            <tr>
                <th class="label">Vendor</th>
                <th style="width:100%;">Instance Type</th>
                <th>Total</th>
            </tr>
            </thead>
            <tr>
                <td>Amazon RDS</td>
                <td>{{awsInstance}} 1-year reserved, no upfront</td>
                <td class="price">{{awsTotal | price}}</td>
            </tr>
            <tr>
                <td>Google Cloud SQL</td>
                <td>Dedicated-core, sustained use</td>
                <td class="price">{{gcpTotal | price}}</td>
            </tr>
            <tr>
                <td>Azure Database</td>
                <td>{{azureInstance}} West US 2</td>
                <td class="price">{{azureTotal | price}}</td>
            </tr>
            <tr>
                <td>Heroku Postgres</td>
                <td>{{herokuInstance}}</td>
                <td class="price">{{herokuTotal | price}}</td>
            </tr>
            <tr>
                <td>Digital Ocean</td>
                <td>
                    {{doInstance.memoryGB}} GB memory,
                    {{doInstance.cores}} vCPU,
                    {{doInstance.storageGB}} GB disk
                </td>
                <td class="price">{{doInstance.price | price}}</td>
            </tr>
            <tr>
                <td>ElephantSQL</td>
                <td>
                    {{elephantInstance.name}}:
                    {{elephantInstance.memoryGB}} GB memory,
                    {{elephantInstance.storageGB}} GB disk
                </td>
                <td class="price">{{elephantInstance.price | price}}</td>
            </tr>
        </table>
    </div>
</template>
<script>
  const HR_PER_MONTH = 730
  const INSTANCE_HOUR = {
    // AWS
    'db.t3.micro': 0.017,
    'db.t3.small': 0.034,
    'db.t3.medium': 0.068,
    'db.t3.large': 0.136,
    'db.t3.xlarge': 0.271,
    'db.t3.2xlarge': 0.543,
    // Azure
    'B_Gen5_1': 0.034,
    'B_Gen5_2': 0.068,
    'GP_Gen5_2': 0.176,
    'GP_Gen5_4': 0.351,
    'GP_Gen5_8': 0.701
  }
  const INSTANCE_MONTH = {
    // Heroku
    'Standard_0': 50,
    'Standard_2': 200,
    'Standard_3': 400,
    'Standard_4': 750,
    'Standard_5': 1400,
  }
  const STORAGE_GB_MONTH = {
    AWS: 0.138,
    GCP: 0.170,
    Azure: 0.115
  }

  // Digital Ocean: memory, vCPU, disk, price/mo
  const DO_PLANS = [
    [1, 1, 10, 15],
    [2, 1, 25, 30],
    [4, 2, 38, 60],
    [8, 4, 115, 120],
    [16, 6, 270, 240],
    [32, 8, 580, 480]
  ]

  // Elephant SQL: name, memory, storage, price
  const ELEPHANT_PLANS= [
    ['Blissful Butterfly', 2, 50, 49],
    ['Happy Hippo', 4, 100, 99],
    ['Enormous Elephant', 8, 250, 199],
    ['Puffy Pigeon', 16, 500, 399],
    ['Dramatic Dolphin', 32, 1000, 749]
  ]

  const priceFmt = new Intl.NumberFormat('en-US', {style: 'currency', currency: 'USD'})
  const PRESETS = [
    {storageGB: 5, cores: 1, memoryGB: 1},
    {storageGB: 10, cores: 2, memoryGB: 2},
    {storageGB: 50, cores: 3, memoryGB: 4},
    {storageGB: 100, cores: 4, memoryGB: 8},
    {storageGB: 200, cores: 6, memoryGB: 16},
    {storageGB: 500, cores: 8, memoryGB: 32}
  ]

  export default {
    name: 'DbaasCalculator',
    data () {
      return {storageGB: 5, cores: 1, memoryGB: 1, presets: PRESETS}
    },
    computed: {
      awsInstance () {
        if (this.cores <= 3 && this.memoryGB <= 8) {
          if (this.memoryGB < 2) return 'db.t3.micro'
          if (this.memoryGB <= 3) return 'db.t3.small'
          if (this.memoryGB <= 4) return 'db.t3.medium'
          if (this.memoryGB <= 8) return 'db.t3.large'
        }
        if (this.cores <= 4 && this.memoryGB <= 16) return 'db.t3.xlarge'
        if (this.cores <= 8 && this.memoryGB <= 32) return 'db.t3.2xlarge'
      },
      awsTotal () {
        return (INSTANCE_HOUR[this.awsInstance] * HR_PER_MONTH) + (STORAGE_GB_MONTH.AWS * this.storageGB)
      },
      gcpTotal () {
        const coreHour = 0.0413 * this.cores
        const memoryHour = 0.0070 * this.memoryGB
        const storageMonth = STORAGE_GB_MONTH.GCP * this.storageGB

        return ((coreHour + memoryHour) * HR_PER_MONTH) + storageMonth
      },
      azureInstance () {
        if (this.cores === 1 && this.memoryGB <= 2) return 'B_Gen5_1'
        if (this.cores <= 2 && this.memoryGB <= 4) return 'B_Gen5_2'
        if (this.cores <= 2 && this.memoryGB <= 10) return 'GP_Gen5_2'
        if (this.cores <= 4 && this.memoryGB <= 20) return 'GP_Gen5_4'
        if (this.cores <= 8 && this.memoryGB <= 40) return 'GP_Gen5_8'
      },
      azureTotal () {
        return (INSTANCE_HOUR[this.azureInstance] * HR_PER_MONTH) + (STORAGE_GB_MONTH.Azure * this.storageGB)
      },
      herokuInstance () {
        if (this.memoryGB <= 4 && this.storageGB <= 64) return 'Standard_0'
        if (this.memoryGB <= 8 && this.storageGB <= 256) return 'Standard_2'
        if (this.memoryGB <= 15 && this.storageGB <= 512) return 'Standard_3'
        if (this.memoryGB <= 30 && this.storageGB <= 750) return 'Standard_4'
        if (this.memoryGB <= 61 && this.storageGB <= 1000) return 'Standard_5'
      },
      herokuTotal () {
        return INSTANCE_MONTH[this.herokuInstance]
      },
      doInstance () {
        const inst = DO_PLANS
          .find(([mem, cpu, disk]) => this.memoryGB <= mem && this.cores <= cpu && this.storageGB <= disk)
        if (inst) return {memoryGB: inst[0], cores: inst[1], storageGB: inst[2], price: inst[3]}
        return {}
      },
      doTotal () {
        return this.doInstance.price
      },
      elephantInstance() {
        const inst = ELEPHANT_PLANS
          .find(([name, mem, disk]) => this.memoryGB <= mem && this.storageGB <= disk)
        if (inst) return {name: inst[0], memoryGB: inst[1], storageGB: inst[2], price: inst[3]}
        return {}
      },
    },
    methods: {
      applyPreset (preset) {
        this.cores = preset.cores
        this.storageGB = preset.storageGB
        this.memoryGB = preset.memoryGB
      }
    },
    filters: {
      price: val => isNaN(val) ? 'N/A' : priceFmt.format(val)
    }
  }
</script>
<style scoped lang="stylus">
    table
        .label
            min-width: 10rem

        .input
            width: 100%

    input[type="range"]
        width: 100%
        background: transparent

    .price
        text-align: right
        min-width: 5rem

    button
        font-size: 1rem
        padding: 0.5rem 1rem
        margin: 0 0.5rem 0.5rem 0
        border: 1px solid #dfe2e5
        background-color: #f6f8fa
        border-radius: 4px
</style>